function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import PropTypes from 'prop-types';
import { polyfill as reactLifecyclesCompat } from 'react-lifecycles-compat';
import classNames from 'classnames';
import ExpandableList from './ExpandableList';
import List from './List';
import Label from './TextInputLabel';
import TextInputInput from './TextInputInput';
import Ellipsis from './Ellipsis';
import WithError from './WithError';
import { onBlurForReduxForm } from './utility/redux-form';
import { submitFormOnCtrlEnter } from './utility/dom'; // `PureComponent` is only available in React >= 15.3.0.

var PureComponent = React.PureComponent || React.Component;
var empty_value_option_value = '';

var Autocomplete = /*#__PURE__*/function (_PureComponent) {
  _inherits(Autocomplete, _PureComponent);

  var _super = _createSuper(Autocomplete);

  function Autocomplete() {
    var _this;

    _classCallCheck(this, Autocomplete);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "state", {
      // The sequential counter for `async getOptions()`:
      // the `options` with the highest counter are shown
      // to prevent "race condition" inconsistency.
      // Older options can only be overwritten with newer ones.
      optionsCounter: 0,
      matchesCounter: 0,
      inputValue: '',
      options: [],
      // `prevProps` for `getDerivedStateFromProps()`.
      props: {}
    });

    _defineProperty(_assertThisInitialized(_this), "latestFetchOptionsCallTimestamp", 0);

    _defineProperty(_assertThisInitialized(_this), "counter", new Counter());

    _defineProperty(_assertThisInitialized(_this), "onPreloadStateChange", function (isPreloading) {
      return _this.setState({
        isFetchingOptions: isPreloading
      });
    });

    _defineProperty(_assertThisInitialized(_this), "focus", function () {
      return _this.input.focus();
    });

    _defineProperty(_assertThisInitialized(_this), "onCollapse", function (_ref) {
      var collapsedDueToItemBeingSelected = _ref.collapsedDueToItemBeingSelected,
          focusOut = _ref.focusOut;
      var _this$state = _this.state,
          options = _this$state.options,
          selectedOption = _this$state.selectedOption;

      _this.setState({
        isExpanded: false,
        matches: undefined
      });

      if (!collapsedDueToItemBeingSelected && !_this.collapsedDueToEmptyValueOnEnter) {
        _this.setState({
          inputValue: selectedOption ? selectedOption.label : ''
        });
      }

      if (!focusOut) {
        _this.dontExpandOnFocus = true;

        _this.focus();

        _this.dontExpandOnFocus = false;
      }
    });

    _defineProperty(_assertThisInitialized(_this), "onExpand", function () {
      var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      _this.setState({
        isExpanded: true
      });
    });

    _defineProperty(_assertThisInitialized(_this), "onFocusItem", function (i, options) {
      if (options.interaction) {
        _this.setState({
          focusedOptionIndex: i
        });
      } else {
        _this.setState({
          focusedOptionIndex: undefined
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "expand", function () {
      // Reset the "matches" state before expanding.
      _this.setState({
        matches: true
      }, _this._expand);
    });

    _defineProperty(_assertThisInitialized(_this), "_expand", function (parameters) {
      return _this.list.expand(parameters);
    });

    _defineProperty(_assertThisInitialized(_this), "collapse", function () {
      return _this.list.collapse();
    });

    _defineProperty(_assertThisInitialized(_this), "toggle", function () {
      return _this.list.toggle();
    });

    _defineProperty(_assertThisInitialized(_this), "storeListRef", function (ref) {
      return _this.list = ref;
    });

    _defineProperty(_assertThisInitialized(_this), "storeInput", function (node) {
      return _this.input = node;
    });

    _defineProperty(_assertThisInitialized(_this), "storeInputComponentNode", function (node) {
      return _this.inputComponentNode = node;
    });

    _defineProperty(_assertThisInitialized(_this), "getInputNode", function () {
      return _this.input;
    });

    _defineProperty(_assertThisInitialized(_this), "expandOnFocus", function () {
      if (_this.dontExpandOnFocus) {
        return;
      }

      var isExpanded = _this.state.isExpanded;

      if (!isExpanded) {
        _this.setState({
          matches: true
        }, _this.expand);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "onInputValueChange", function (value) {
      var isExpanded = _this.state.isExpanded; // Rewrite this somehow.
      //
      // When `highlightFirstOption` is `true`
      // this is a special case when the first option is not highlighted.

      if (!value && isExpanded) {
        _this.list.focusItem(undefined);
      }

      _this.setState({
        inputValue: value
      }, function () {
        _this._expand({
          refresh: true
        });
      });
    });

    _defineProperty(_assertThisInitialized(_this), "onKeyDown", function (event) {
      var _this$props = _this.props,
          disabled = _this$props.disabled,
          readOnly = _this$props.readOnly,
          value = _this$props.value,
          required = _this$props.required,
          highlightFirstOption = _this$props.highlightFirstOption,
          onKeyDown = _this$props.onKeyDown;
      var _this$state2 = _this.state,
          options = _this$state2.options,
          isExpanded = _this$state2.isExpanded,
          inputValue = _this$state2.inputValue,
          focusedOptionIndex = _this$state2.focusedOptionIndex;

      if (disabled || readOnly) {
        return;
      }

      if (event.defaultPrevented) {
        return;
      }

      if (!isExpanded) {
        if (submitFormOnCtrlEnter(event, _this.input)) {
          return;
        }
      }

      if (event.ctrlKey || event.altKey || event.shiftKey || event.metaKey) {
        return;
      }

      switch (event.keyCode) {
        // "Up" arrow.
        // Select the previous item (if present).
        case 38:
          if (isExpanded) {
            // If no item was selected then do nothing.
            if (_this.list.getFocusedItemIndex() === undefined) {// Don't select any list item.
            } // If the first item was selected.
            else if (_this.list.getFocusedItemIndex() === 0) {
              // then unselect it.
              if (!highlightFirstOption) {
                _this.list.clearFocus();
              }

              event.preventDefault();
            } else {
              _this.list.onKeyDown(event);
            }
          }

          return;
        // "Down" arrow.
        // Select the next item (if present).

        case 40:
          if (isExpanded) {
            // An edge case for `highlightFirstOption`
            // when there's only one option available
            // so pressing "Down" arrow key won't result in
            // `onFocusItem` call which won't set `focusedOptionIndex`
            // in order for screen reader to announce it.
            if (highlightFirstOption && focusedOptionIndex === undefined && options.length === 1) {
              _this.setState({
                focusedOptionIndex: 0
              });
            } else {
              // Navigate the list (if it was already expanded).
              _this.list.onKeyDown(event);
            }
          } else {
            // Expand the list if it's collapsed.
            event.preventDefault();

            _this.expand();
          }

          return;
        // "Left" arrow.

        case 37: // "Right" arrow.

        case 39:
          // Exit "focus options" mode.
          if (isExpanded) {
            _this.list.clearFocus();

            if (highlightFirstOption) {
              _this.list.focusItem(0);
            }
          }

          return;
        // "Escape".
        // Collapse.

        case 27:
          if (isExpanded) {
            event.preventDefault();

            _this.collapse();
          } else {
            if (onKeyDown) {
              onKeyDown(event);
            }
          }

          return;
        // "Enter".

        case 13:
          if (!inputValue) {
            if (onKeyDown) {
              onKeyDown(event);
            } // If no option is selected and the input value is empty
            // then set `value` to `undefined`.


            if (isExpanded && _this.list.getFocusedItemIndex() === undefined) {
              // Don't submit the form.
              event.preventDefault();

              _this.setValue(undefined);

              _this.collapsedDueToEmptyValueOnEnter = true;

              _this.collapse();

              _this.collapsedDueToEmptyValueOnEnter = undefined;
              return;
            }

            if (!isExpanded) {
              // If `value` is `undefined` and input value is empty
              // then by default it submits the form.
              if (isEmptyValue(value)) {
                // If the value is required then expand the options list.
                if (required) {
                  // Don't submit the form
                  event.preventDefault();

                  _this.expand();
                }

                return;
              } // If the input value has been cleared
              // and the options list is collapsed
              // (for example, via Escape key)
              // then set `value` to `undefined`
              // and don't submit the form.


              event.preventDefault();

              _this.setValue(undefined);

              return;
            }
          } // Select the currently focused item (if expanded).


          if (isExpanded) {
            // Don't submit the form.
            event.preventDefault(); // Choose the focused option.

            _this.list.chooseFocusedItem();
          }

          return;
      }
    });

    _defineProperty(_assertThisInitialized(_this), "fetchDefaultOptions", function () {
      var _this$props2 = _this.props,
          getOptions = _this$props2.getOptions,
          filterOptions = _this$props2.filterOptions;
      return Promise.resolve().then(function () {
        return getOptions ? getOptions('') : filterOptions(_this.props.options, '');
      }).then(function (options) {
        return new Promise(function (resolve) {
          return _this.setState({
            options: options
          }, resolve);
        });
      });
    });

    _defineProperty(_assertThisInitialized(_this), "refreshOptions", function () {
      var _this$props3 = _this.props,
          getOptions = _this$props3.getOptions,
          filterOptions = _this$props3.filterOptions;
      var inputValue = _this.state.inputValue;
      return new Promise(function (resolve) {
        // If throttled then schedule a future invocation.
        if (getOptions) {
          if (_this.throttleFetchOptionsCall(resolve)) {
            return;
          }

          _this.latestFetchOptionsCallTimestamp = Date.now();

          var counter = _this.counter.getNextCounter();

          return _this.setState({
            isFetchingOptions: true,
            fetchingOptionsCounter: counter
          }, function () {
            getOptions(inputValue).then(function (options) {
              _this.handleNewOptions(options, counter, resolve);
            });
          });
        }

        var newOptions = filterOptions(_this.props.options, inputValue);

        _this.handleNewOptions(newOptions, null, resolve);
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleNewOptions", function (options, counter, resolve) {
      Promise.resolve(options).then(function (options) {
        // Autocomplete should always display some options.
        if (options.length === 0 && _this.state.options.length === 0) {
          return _this.fetchDefaultOptions().then(function () {
            return options;
          });
        }

        return options;
      }).then(function (options) {
        _this.receiveNewOptions(options, counter, resolve);
      })["catch"](function (error) {
        console.error(error);

        _this.receiveNewOptions([], counter, resolve);
      });
    });

    _defineProperty(_assertThisInitialized(_this), "setValue", function (newValue) {
      var _this$props4 = _this.props,
          value = _this$props4.value,
          onChange = _this$props4.onChange;
      var options = _this.state.options;
      var selectedOption = options.filter(function (_) {
        return _.value === newValue;
      })[0];

      _this.setState({
        selectedOption: selectedOption,
        inputValue: selectedOption ? selectedOption.label : ''
      }); // Call `onChange` only if the `value` did change.


      if (newValue !== value) {
        onChange(newValue);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "onBlur", function (event) {
      var _this$props5 = _this.props,
          onBlur = _this$props5.onBlur,
          value = _this$props5.value;

      if (onBlur) {
        onBlurForReduxForm(onBlur, event, value);
      }

      if (_this.list) {
        _this.list.onBlur(event);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "onClick", function (event) {
      var _this$props6 = _this.props,
          disabled = _this$props6.disabled,
          readOnly = _this$props6.readOnly;

      if (disabled || readOnly) {
        return;
      }

      _this.expandOnFocus();
    });

    _defineProperty(_assertThisInitialized(_this), "onFocusOut", function (event) {
      var _this$props7 = _this.props,
          onBlur = _this$props7.onBlur,
          value = _this$props7.value;
      var inputValue = _this.state.inputValue; // `window.rruiCollapseOnFocusOut` can be used
      // for debugging expandable contents.

      if (window.rruiCollapseOnFocusOut !== false) {
        _this.collapse();
      }

      if (!inputValue) {
        value = undefined;

        _this.setValue(value);
      }

      if (onBlur) {
        onBlurForReduxForm(onBlur, event, value);
      }
    });

    return _this;
  }

  _createClass(Autocomplete, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      var _this$props8 = this.props,
          value = _this$props8.value,
          getOptions = _this$props8.getOptions,
          getOption = _this$props8.getOption; // Generate unique ID.

      var id = "rrui-autocomplete";

      while (document.getElementById("".concat(id, "__input"))) {
        id = "rrui-autocomplete-".concat(generateRandomString());
      }

      this.input.id = "".concat(id, "__input");
      this.setState({
        id: id
      });

      if (!isEmptyValue(value) && !getOption && getOptions) {
        throw new Error("An initial `value` was passed to `<Autocomplete/>` which has `getOptions` but doesn't have `getOption` to get the label for that initial `value`.");
      }

      if (!isEmptyValue(value) && getOption) {
        this.setState({
          isFetchingInitiallySelectedOption: true
        });
        getOption(value).then(function (option) {
          _this2.setState({
            selectedOption: option,
            inputValue: option ? option.label : '',
            isFetchingInitiallySelectedOption: false
          });
        }, function (error) {
          console.error(error);

          _this2.setState({
            isFetchingInitiallySelectedOption: false
          });
        });
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      clearTimeout(this.nextFetchOptionsCallTimeout);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props9 = this.props,
          icon = _this$props9.icon,
          compact = _this$props9.compact,
          scroll = _this$props9.scroll,
          scrollMaxItems = _this$props9.scrollMaxItems,
          scrollIntoView = _this$props9.scrollIntoView,
          alignment = _this$props9.alignment,
          saveOnIcons = _this$props9.saveOnIcons,
          highlightFirstOption = _this$props9.highlightFirstOption,
          optionComponent = _this$props9.optionComponent,
          required = _this$props9.required,
          label = _this$props9.label,
          placeholder = _this$props9.placeholder,
          value = _this$props9.value,
          onChange = _this$props9.onChange,
          showErrorMessage = _this$props9.showErrorMessage,
          error = _this$props9.error,
          closeButtonIcon = _this$props9.closeButtonIcon,
          closeLabel = _this$props9.closeLabel,
          ScrollableContainer = _this$props9.ScrollableContainer,
          style = _this$props9.style,
          className = _this$props9.className;
      var _this$state3 = this.state,
          id = _this$state3.id,
          options = _this$state3.options,
          isFetchingOptions = _this$state3.isFetchingOptions,
          isFetchingInitiallySelectedOption = _this$state3.isFetchingInitiallySelectedOption,
          isExpanded = _this$state3.isExpanded,
          inputValue = _this$state3.inputValue;
      var containerStyle = {
        textAlign: alignment
      }; // ARIA 1.1 (accessibility) docs:
      // https://www.w3.org/TR/wai-aria-practices/examples/combobox/aria1.1pattern/listbox-combo.html
      // (not yet supported)
      //
      // ARIA 1.0 (accessibility) docs:
      // https://www.w3.org/TR/wai-aria-practices/examples/combobox/aria1.0pattern/combobox-autocomplete-list.html
      // (is supported)
      // value={options.length === 0 ? undefined : (inputValue.trim() === '' ? undefined : value)}

      return /*#__PURE__*/React.createElement(WithError, {
        id: id,
        error: showErrorMessage ? error : undefined,
        style: style ? _objectSpread(_objectSpread({}, containerStyle), style) : containerStyle,
        className: classNames(className, 'rrui__autocomplete', {
          'rrui__autocomplete--expanded': isExpanded,
          'rrui__autocomplete--compact': compact || icon === true
        })
      }, /*#__PURE__*/React.createElement("div", {
        ref: this.storeInputComponentNode,
        className: "rrui__input"
      }, (isFetchingOptions || isFetchingInitiallySelectedOption) && /*#__PURE__*/React.createElement(Ellipsis, null), this.renderTextInput(), label && /*#__PURE__*/React.createElement(Label, {
        "aria-hidden": true,
        inputId: id ? "".concat(id, "__input") : undefined,
        value: value,
        required: required,
        invalid: error
      }, label), /*#__PURE__*/React.createElement(ExpandableList, {
        ref: this.storeListRef,
        id: id ? "".concat(id, "__list") : undefined,
        items: options,
        value: options.length === 0 ? undefined : value,
        highlightFirstItem: highlightFirstOption && inputValue.trim() !== '',
        alignment: alignment,
        scrollIntoView: scrollIntoView,
        preload: this.refreshOptions,
        onPreloadStateChange: this.onPreloadStateChange,
        onFocusItem: this.onFocusItem,
        scrollMaxItems: scroll === false ? 0 : scrollMaxItems,
        shouldFocus: false,
        onChange: this.setValue,
        onCollapse: this.onCollapse,
        onExpand: this.onExpand,
        focusOnExpand: false,
        highlightSelectedItem: false,
        tabbable: false,
        getTogglerNode: this.getInputNode,
        onFocusOut: this.onFocusOut,
        ScrollableContainer: ScrollableContainer,
        closeButtonIcon: closeButtonIcon,
        closeLabel: closeLabel,
        "aria-label": this.props['aria-label'] || label,
        className: classNames('rrui__shadow', 'rrui__options-list', {
          'rrui__options-list--left-aligned': alignment === 'left',
          'rrui__options-list--right-aligned': alignment === 'right'
        })
      }, this.getOptionsForRendering().map(function (option, i) {
        return /*#__PURE__*/React.createElement(List.Item, {
          key: i,
          id: id ? "".concat(id, "__list-item-").concat(i) : undefined,
          value: option.value,
          item: optionComponent ? option : undefined,
          component: optionComponent,
          icon: saveOnIcons ? undefined : option.icon
        }, optionComponent ? undefined : option.content ? option.content(option) : option.label);
      }))));
    }
  }, {
    key: "renderTextInput",
    value: function renderTextInput() {
      var _this$props10 = this.props,
          value = _this$props10.value,
          label = _this$props10.label,
          icon = _this$props10.icon,
          placeholder = _this$props10.placeholder,
          disabled = _this$props10.disabled,
          readOnly = _this$props10.readOnly,
          required = _this$props10.required,
          error = _this$props10.error,
          tabIndex = _this$props10.tabIndex,
          autoFocus = _this$props10.autoFocus,
          autoComplete = _this$props10.autoComplete,
          inputClassName = _this$props10.inputClassName;
      var _this$state4 = this.state,
          id = _this$state4.id,
          isExpanded = _this$state4.isExpanded,
          inputValue = _this$state4.inputValue,
          matches = _this$state4.matches,
          isFetchingInitiallySelectedOption = _this$state4.isFetchingInitiallySelectedOption,
          focusedOptionIndex = _this$state4.focusedOptionIndex; // To expand on click/focus:
      // onFocus={ this.expandOnFocus }
      // onClick={ this.onClick }
      // WAI-ARIA 1.0 impelmentation info (accessibility):
      // https://www.w3.org/TR/wai-aria-practices/#combobox
      // https://www.levelaccess.com/differences-aria-1-0-1-1-changes-rolecombobox/

      var Icon = typeof icon === 'boolean' ? undefined : icon;
      return /*#__PURE__*/React.createElement(React.Fragment, null, Icon && /*#__PURE__*/React.createElement(Icon, {
        className: "rrui__input-field__icon"
      }), /*#__PURE__*/React.createElement(TextInputInput, {
        id: id ? "".concat(id, "__input") : undefined,
        ref: this.storeInput,
        value: inputValue,
        label: label,
        placeholder: placeholder,
        onChange: this.onInputValueChange,
        onKeyDown: this.onKeyDown,
        onBlur: this.onBlur,
        role: "combobox",
        "aria-autocomplete": "list",
        "aria-expanded": isExpanded ? true : false,
        "aria-haspopup": true,
        "aria-owns": id && isExpanded ? "".concat(id, "__list") : undefined,
        "aria-activedescendant": id && focusedOptionIndex !== undefined ? "".concat(id, "__list-item-").concat(focusedOptionIndex) : undefined,
        required: required,
        tabIndex: tabIndex,
        autoFocus: autoFocus,
        autoComplete: autoComplete,
        disabled: disabled,
        readOnly: isFetchingInitiallySelectedOption || readOnly,
        error: error || (matches === false ? 'no-match' : undefined),
        className: classNames('rrui__autocomplete__input', inputClassName, {
          'rrui__input-field--with-icon': Icon
        })
      }));
    }
  }, {
    key: "getOptionsForRendering",
    value: function getOptionsForRendering() {
      var maxOptions = this.props.maxOptions;
      var options = this.state.options;

      if (maxOptions > 0 && options.length > maxOptions) {
        return options.slice(0, maxOptions);
      }

      return options;
    }
  }, {
    key: "throttleFetchOptionsCall",
    value: function throttleFetchOptionsCall(resolve) {
      var _this3 = this;

      var _this$props11 = this.props,
          throttle = _this$props11.throttle,
          minCharactersToStartThrottling = _this$props11.minCharactersToStartThrottling;
      var inputValue = this.state.inputValue;
      var wait = throttle - (Date.now() - this.latestFetchOptionsCallTimestamp);

      if (inputValue.length >= minCharactersToStartThrottling && wait > 0) {
        if (!this.nextFetchOptionsCallTimeout) {
          this.nextFetchOptionsCallTimeout = setTimeout(function () {
            _this3.nextFetchOptionsCallTimeout = undefined;

            _this3.latestFetchOptionsCall();
          }, wait);
        }

        this.latestFetchOptionsCall = function () {
          return _this3.refreshOptions().then(resolve);
        };

        return true;
      }
    }
  }, {
    key: "receiveNewOptions",
    value: function receiveNewOptions(options, counter, callback) {
      var _this$props12 = this.props,
          getOptions = _this$props12.getOptions,
          highlightFirstOption = _this$props12.highlightFirstOption;
      var _this$state5 = this.state,
          isExpanded = _this$state5.isExpanded,
          matchesCounter = _this$state5.matchesCounter,
          optionsCounter = _this$state5.optionsCounter,
          fetchingOptionsCounter = _this$state5.fetchingOptionsCounter;
      var newState = {};

      if (getOptions) {
        // Can only override "older" matching state.
        if (isCounterAfter(counter, matchesCounter)) {
          newState.matches = options.length > 0;
          newState.matchesCounter = counter;
        } // Update options.
        // Can only override "older" options.
        // (not "newer" ones)


        if (isCounterAfter(counter, optionsCounter)) {
          // Autocomplete should always display some options.
          if (options.length > 0) {
            newState.options = options;
            newState.optionsCounter = counter;
          }
        }

        if (counter === fetchingOptionsCounter) {
          newState.isFetchingOptions = false;
          newState.fetchingOptionsCounter = undefined;
        }
      } else {
        newState.matches = options.length > 0; // Autocomplete should always display some options.

        if (options.length > 0) {
          newState.options = options;
        }
      }

      if (newState.matches === false && !highlightFirstOption) {
        if (isExpanded) {
          this.list.clearFocus();
        }
      }

      this.setState(newState, callback);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: // Handles changing `value` externally for an `<Autocomplete/>`.
    function getDerivedStateFromProps(_ref2, state) {
      var value = _ref2.value,
          options = _ref2.options;
      var newState = {
        // `prevProps`.
        props: {
          value: value
        }
      }; // Changing `value` externally for an `<Autocomplete/>`
      // with `async getOptions()` is not supported.

      if (Array.isArray(options)) {
        // `<Autocomplete/>`'s selected option label
        // is stored in a special `selectedOption.label` variable in `state`.
        if (value !== state.props.value) {
          newState.selectedOption = options.filter(function (_) {
            return _.value === value;
          })[0];
          newState.inputValue = newState.selectedOption ? newState.selectedOption.label : '';
        }
      }

      return newState;
    }
  }]);

  return Autocomplete;
}(PureComponent);

_defineProperty(Autocomplete, "propTypes", {
  // A list of selectable options
  options: PropTypes.arrayOf(PropTypes.shape({
    // Option value (may be `undefined`)
    value: PropTypes.any,
    // Could restrict it to stringifiable types
    // but I guess this is not required
    // and one could even use `object`s as `value`s.
    // // Option value (may be `undefined`)
    // value : PropTypes.oneOfType([
    // 	PropTypes.string,
    // 	PropTypes.number,
    // 	PropTypes.bool
    // ]),
    // Option label (may be `undefined`)
    label: PropTypes.string,
    // Option icon
    icon: PropTypes.oneOfType([PropTypes.node, PropTypes.func]),
    // Render custom content (a React component).
    // Receives `{ value, label }` properties.
    content: PropTypes.func
  })),
  // An alternative way of getting `options`.
  // If it's an `autocomplete` then this function
  // receives the `query : string` argument.
  // Is only for `autocomplete` mode.
  // Must return a `Promise`.
  getOptions: PropTypes.func,
  // Can be supplied when supplying `options` prop.
  // By default filters by substring inclusion (case-insensitive).
  filterOptions: PropTypes.func.isRequired,
  // The maximum number of options to be rendered
  // in the options list when it's expanded.
  // `0` means "unlimited".
  maxOptions: PropTypes.number,
  // Throttle `async getOptions()` invocations.
  throttle: PropTypes.number.isRequired,
  // Throttle `async getOptions()` invocations.
  minCharactersToStartThrottling: PropTypes.number.isRequired,
  // Option component.
  // (when `<Autocomplete/>` is expanded).
  // Receives properties:
  // * `{ ...option }` — All properties of an `option` such as `value`, `label`, etc. Each `option` must have a `value` and a `label` (`value` may be `undefined`).
  // * `selected: boolean` — If this option is selected.
  // * `focused: boolean` — If this option is focused.
  // * `disabled: boolean` — If this option is disabled. Seems to be not used for now.
  // Can only contain "inline" elements like `<span/>`,
  // not `<div/>`s, `<section/`>s, `<h1/>`s or `<p/>`s,
  // because `<button/>`s can't contain "block" elements.
  // `display: block` can still be set on `<span/>`s and other "inline" elements.
  optionComponent: PropTypes.elementType,
  // HTML form input `name` attribute
  name: PropTypes.string,
  // Label which is placed above the select
  label: PropTypes.string,
  // Placeholder (like "Choose")
  placeholder: PropTypes.string,
  // Show icon only for selected item,
  // and only if `icon` is `true`.
  saveOnIcons: PropTypes.bool,
  // Disables this control
  disabled: PropTypes.bool,
  // HTML `readOnly` attribute
  readOnly: PropTypes.bool,
  // Set to `true` to mark the field as required
  required: PropTypes.bool.isRequired,
  // Indicates that the input is invalid.
  error: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  showErrorMessage: PropTypes.bool,
  // Selected option value
  value: PropTypes.any,
  // Is called when an option is selected
  onChange: PropTypes.func,
  // Is called when the select is blurred.
  // This `onBlur` interceptor is a workaround for `redux-form`,
  // so that it gets the parsed `value` in its `onBlur` handler,
  // not the formatted text.
  onBlur: PropTypes.func,
  // If `scroll` is `false`, then options list
  // is not limited in height.
  // Is `true` by default (scrollable).
  scroll: PropTypes.bool.isRequired,
  // Component CSS class
  className: PropTypes.string,
  // Autocomplete `<input/>` CSS class
  inputClassName: PropTypes.string,
  // CSS style object
  style: PropTypes.object,
  // If the `icon` flag is set to `true`,
  // and `icon` is specified for a selected option,
  // then the selected option will be displayed
  // as icon only, without the label
  // (was used in early versions of `react-phone-number-input`).
  // Otherwise, if it's a React component
  // then it's passed to `<TextInputInput/>` as its `icon`.
  icon: PropTypes.oneOfType([PropTypes.elementType, PropTypes.bool]),
  // If this flag is set to `true`,
  // then it makes `<Autocomplete/>` not stretch itself
  // to 100% width by making it `inline-block`.
  // Is set to `true` when `icon` is `true`
  // because it makes sense.
  compact: PropTypes.bool,
  // HTML `tabindex` attribute
  tabIndex: PropTypes.number,
  // HTML `autoFocus` attribute
  autoFocus: PropTypes.bool,
  // `onKeyDown()` doesn't get called in all cases.
  // Currently it's only called in cases:
  // * Pressed `Esc` when the options list is not expanded.
  // * Pressed `Enter` when the input is empty.
  onKeyDown: PropTypes.func,
  // HTML `autocomplete` attribute.
  // Set to "off" to disable any autocompletion in a web browser.
  // https://developer.mozilla.org/en-US/docs/Web/Security/Securing_your_site/Turning_off_form_autocompletion
  autoComplete: PropTypes.string,
  // `<Autocomplete/>` loads `async getOptions()` after it has been mounted.
  // Until then `<Autocomplete/>` doesn't display any selected option.
  // One may supply an already pre-loaded currently selected option
  // to display the currently selected option sooner (e.g. Server-Side Rendering).
  selectedOption: PropTypes.object,
  // WAI-ARIA requires any option be focused only on-demand
  // when the user explicitly presses the Down arrow key.
  // https://www.w3.org/TR/wai-aria-practices/examples/combobox/aria1.0pattern/combobox-autocomplete-list.html
  // Still, it's not be the best user experience for non-disabled users:
  // it would be more convenient for them if the first option was automatically focused.
  // Hence this property.
  // (is `false` by default for WAI-ARIA compliancy)
  highlightFirstOption: PropTypes.bool.isRequired,
  ScrollableContainer: PropTypes.elementType
});

_defineProperty(Autocomplete, "defaultProps", {
  // Set to `true` to mark the field as required
  required: false,
  // Show `error` (if passed).
  showErrorMessage: true,
  // Set to `true` to display the loading indicator
  loading: false,
  // Will show scrollbar on overflow.
  scroll: true,
  alignment: 'left',
  // `async getOptions()` throttle period.
  throttle: 200,
  // `async getOptions()` throttle threshold (in characters).
  minCharactersToStartThrottling: 4,
  // Filters options by substring inclusion (case-insensitive).
  filterOptions: filterOptions,
  // The maximum number of options to be rendered
  // in the options list when it's expanded.
  // The rationale is that otherwise the UI could
  // stagger when initially expanding a huge list.
  // `0` means "unlimited".
  maxOptions: 500,
  // UX for non-disabled users is better this way.
  // Disabled users still can use this component.
  highlightFirstOption: true
});

export default reactLifecyclesCompat(Autocomplete);

function isEmptyValue(value) {
  return value === null || value === undefined;
} // Filters options by substring inclusion (case-insensitive).


function filterOptions(options, value) {
  // If the input value is `undefined` or empty.
  if (!value) {
    return options;
  }

  value = value.toLowerCase();
  return options.filter(function (_ref3) {
    var label = _ref3.label;
    return label.toLowerCase().indexOf(value) >= 0;
  });
}

var Counter = /*#__PURE__*/function () {
  function Counter() {
    _classCallCheck(this, Counter);

    _defineProperty(this, "counter", 0);
  }

  _createClass(Counter, [{
    key: "getNextCounter",
    value: function getNextCounter() {
      if (this.counter < MAX_SAFE_INTEGER) {
        this.counter++;
      } else {
        this.counter = 1;
      }

      return this.counter;
    }
  }]);

  return Counter;
}(); // `MAX_SAFE_INTEGER` is not supported by older browsers


var MAX_SAFE_INTEGER = Number.MAX_SAFE_INTEGER || Math.pow(2, 53) - 1; // Can only override "older" options.
// (not "newer" ones)

function isCounterAfter(counter, currentStateCounter) {
  var diff = counter - currentStateCounter; // If the new options are "newer" than the current ones,
  // then they can override them.
  // (also accounts for counter overflow)

  return diff > 0 || diff < 0 && Math.abs(diff) > MAX_SAFE_INTEGER / 2;
}

function generateRandomString() {
  return Math.random().toString().replace(/\D/g, '');
}
//# sourceMappingURL=Autocomplete.js.map